'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ContentHelper = require('./ContentHelper');

var _ContentHelper2 = _interopRequireDefault(_ContentHelper);

var propTypes = {
    // Rendered on success
    children: _react.PropTypes.node.isRequired,

    // Rendered during load
    loadingIndicator: _react.PropTypes.node.isRequired,

    // Array of content urls to be preloaded
    content: _react.PropTypes.array,

    // Shows percentage loaded
    showPercentage: _react.PropTypes.bool,

    // If set, the preloader will automatically show
    // the children content after this amount of time
    autoResolveDelay: _react.PropTypes.number,

    // Error callback. Is passed the error
    onError: _react.PropTypes.func,

    // Success callback
    onSuccess: _react.PropTypes.func,

    // Success callback
    onItemSuccess: _react.PropTypes.func,

    // Whether or not we should still show the content
    // even if there is a preloading error
    resolveOnError: _react.PropTypes.bool,

    // Whether or not we should mount the child content after
    // content have finished loading (or after autoResolveDelay)
    mountChildren: _react.PropTypes.bool
};

var defaultProps = {
    content: [],
    resolveOnError: true,
    mountChildren: true
};

var Preload = (function (_Component) {
    _inherits(Preload, _Component);

    function Preload(props) {
        _classCallCheck(this, Preload);

        _get(Object.getPrototypeOf(Preload.prototype), 'constructor', this).call(this, props);

        this.state = {
            ready: false,
            error: false,
            loaded: 0
        };

        this._handleSuccess = this._handleSuccess.bind(this);
        this._handleError = this._handleError.bind(this);
        this._handleItemSuccess = this._handleItemSuccess.bind(this);
    }

    _createClass(Preload, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (!this.props.content || this.props.content.length === 0) {
                this._handleSuccess();
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!this.state.ready) {
                _ContentHelper2['default'].loadContent(this.props.content, this._handleItemSuccess.bind(this)).then(this._handleSuccess, this._handleError);

                if (this.props.autoResolveDelay && this.props.autoResolveDelay > 0) {
                    this.autoResolveTimeout = setTimeout(this._handleSuccess, this.props.autoResolveDelay);
                }
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.autoResolveTimeout) {
                clearTimeout(this.autoResolveTimeout);
            }
        }
    }, {
        key: '_handleItemSuccess',
        value: function _handleItemSuccess(success) {
            if (success) {
                if (this.props.onItemSuccess) {
                    this.props.onItemSuccess(this.state.loaded + 1);
                }
                this.setState({
                    loaded: this.state.loaded + 1
                });
            }
        }
    }, {
        key: '_handleSuccess',
        value: function _handleSuccess(result) {
            if (this.autoResolveTimeout) {
                clearTimeout(this.autoResolveTimeout);
                console.warn('content failed to preload, auto resolving');
            }

            if (this.state.ready) {
                return;
            }

            if (this.state.loaded !== this.props.content.length) {
                this.setState({
                    loaded: this.props.content.length
                });
            }

            this.setState({
                ready: true
            });

            if (this.props.onSuccess) {
                this.props.onSuccess(result);
            }
        }
    }, {
        key: '_handleError',
        value: function _handleError(err) {
            if (this.props.resolveOnError) {
                this._handleSuccess();
            }

            this.setState({
                error: true
            });

            if (this.props.onError) {
                this.props.onError(err);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                'span',
                null,
                this.props.showPercentage && !this.state.error ? _react2['default'].createElement(
                    'span',
                    null,
                    Math.round(this.state.loaded * 100 / this.props.content.length),
                    '% '
                ) : null,
                !this.state.error ? _react2['default'].createElement(
                    'span',
                    null,
                    this.state.ready && this.props.mountChildren ? this.props.children : this.props.loadingIndicator
                ) : null
            );
        }
    }]);

    return Preload;
})(_react.Component);

Preload.propTypes = propTypes;
Preload.defaultProps = defaultProps;

exports['default'] = Preload;
module.exports = exports['default'];